Index: java/main/src/test/resources/netfiles/standard.expt
===================================================================
--- java/main/src/test/resources/netfiles/standard.expt	(revision 105)
+++ java/main/src/test/resources/netfiles/standard.expt	(revision 107)
@@ -5,4 +5,5 @@
 overwrite:1
 filecomm:1
+lastCheckpoint:@Serialized:165
 createrr:1
 creatwarnfail:0
@@ -11,4 +12,6 @@
 groupchk:0
 resetonexpdef:1
+user:@Serialized:null
+identity:-1
 initialgen:X
 capacity:200
@@ -17,32 +20,32 @@
 rotation:0
 creath:0.1
-p_nop:20
+p_nop:20.0
 evalcount:0
-p_mut:64
-p_xov:16
-xov_mins:0
+p_mut:64.0
+p_xov:16.0
+xov_mins:0.0
 selrule:2
 delrule:0
-cr_c:0
-cr_life:0
-cr_v:1
-cr_gl:0
-cr_joints:0
-cr_nnsiz:0
-cr_nncon:0
-cr_di:0
-cr_vpos:0
-cr_vvel:0
+cr_c:0.0
+cr_life:0.0
+cr_v:1.0
+cr_gl:0.0
+cr_joints:0.0
+cr_nnsiz:0.0
+cr_nncon:0.0
+cr_di:0.0
+cr_vpos:0.0
+cr_vvel:0.0
 cr_norm:0
 cr_simi:0
-Energy0:5000
-e_meta:1
+Energy0:5000.0
+e_meta:1.0
 feed:0
-feede0:200
+feede0:200.0
 foodgen:
-feedtrans:1
+feedtrans:1.0
 aging:0
 stagnation:0
-minfitness:0
+minfitness:0.0
 boostphase:1
 makesound:0
@@ -50,22 +53,22 @@
 log:0
 notes:
-totaltestedcr:36
-totaltests:36
+totaltestedcr:165
+totaltests:165
 wrldtyp:0
-wrldsiz:20
+wrldsiz:20.0
 wrldmap:
-wrldwat:-1
+wrldwat:-1.0
 wrldbnd:0
-wrldg:1
+wrldg:1.0
 simtype:0
-nnspeed:1
+nnspeed:1.0
 odeshape:0
 odestep:0.05
-odemusclemin:0
-odemusclemax:10
-odemusclespeed:1
+odemusclemin:0.0
+odemusclemax:10.0
+odemusclespeed:1.0
 odeairdrag:0.01
 odewaterdrag:0.5
-odewaterbuoy:1
+odewaterbuoy:1.0
 odeseed:0
 odesepsticks:0
@@ -73,15 +76,15 @@
 odeworldcfm:1e-05
 odecolmumin:0.1
-odecolmumax:5
+odecolmumax:5.0
 odecolbounce:0.1
 odecolbouncevel:0.01
-odecolsoftcfm:0
-odecolsofterp:0
+odecolsoftcfm:0.0
+odecolsofterp:0.0
 odecol2mumin:0.1
-odecol2mumax:1
+odecol2mumax:1.0
 odecol2bounce:0.1
 odecol2bouncevel:0.01
-odecol2softcfm:0
-odecol2softerp:0
+odecol2softcfm:0.0
+odecol2softerp:0.0
 gen_hilite:1
 gen_extmutinfo:0
@@ -123,27 +126,27 @@
 f0_nodel_tag:1
 f0_nomod_tag:1
-f0_p_new:5
-f0_p_del:5
-f0_p_swp:10
-f0_p_pos:10
-f0_p_mas:10
-f0_p_frc:10
-f0_p_ing:10
-f0_p_asm:10
-f0_p_vsiz:0
-f0_j_new:5
-f0_j_del:5
-f0_j_stm:10
-f0_j_stf:10
-f0_j_rsf:10
-f0_j_vred:0
-f0_j_vgrn:0
-f0_j_vblu:0
-f0_n_new:5
-f0_n_del:5
-f0_n_prp:10
-f0_c_new:5
-f0_c_del:5
-f0_c_wei:10
+f0_p_new:5.0
+f0_p_del:5.0
+f0_p_swp:10.0
+f0_p_pos:10.0
+f0_p_mas:10.0
+f0_p_frc:10.0
+f0_p_ing:10.0
+f0_p_asm:10.0
+f0_p_vsiz:0.0
+f0_j_new:5.0
+f0_j_del:5.0
+f0_j_stm:10.0
+f0_j_stf:10.0
+f0_j_rsf:10.0
+f0_j_vred:0.0
+f0_j_vgrn:0.0
+f0_j_vblu:0.0
+f0_n_new:5.0
+f0_n_del:5.0
+f0_n_prp:10.0
+f0_c_new:5.0
+f0_c_del:5.0
+f0_c_wei:10.0
 f1_xo_propor:0
 f1_smX:0.05
@@ -155,5 +158,5 @@
 f1_nmConn:0.1
 f1_nmProp:0.1
-f1_nmWei:1
+f1_nmWei:1.0
 f1_nmVal:0.05
 f2_mutAddOper:0.4
@@ -173,12 +176,12 @@
 f3_xovGeneTransfer:0.8
 f3_xovCrossingOver:0.2
-f4_mut_add:50
-f4_mut_add_div:20
-f4_mut_add_conn:15
-f4_mut_add_neupar:5
-f4_mut_add_rep:10
-f4_mut_add_simp:50
-f4_mut_del:20
-f4_mut_mod:30
+f4_mut_add:50.0
+f4_mut_add_div:20.0
+f4_mut_add_conn:15.0
+f4_mut_add_neupar:5.0
+f4_mut_add_rep:10.0
+f4_mut_add_simp:50.0
+f4_mut_del:20.0
+f4_mut_mod:30.0
 genkonw0:1
 genkonw1:1
@@ -187,8 +190,8 @@
 genkonw4:1
 randinit:0.01
-nnoise:0
-touchrange:1
-bnoise_struct:0
-bnoise_vel:0
+nnoise:0.0
+touchrange:1.0
+bnoise_struct:0.0
+bnoise_vel:0.0
 ncl_N:1
 ncl_Nu:1
@@ -222,12 +225,12 @@
 ncl_SeeLight2:1
 simil_method:0
-simil_parts:0
-simil_partdeg:1
+simil_parts:0.0
+simil_partdeg:1.0
 simil_neuro:0.5
 symPosSteps:10
 symAlphaSteps:20
 symBetaSteps:20
-minjoint:0
-maxjoint:2
+minjoint:0.0
+maxjoint:2.0
 
 GenePool:
@@ -235,57 +238,57 @@
 fitness:return 0.0+this.velocity*1.0;
 fitfun:0
-fitm:2
-fitma:2
-
-org:
+fitm:2.0
+fitma:2.0
+
+Genotype:
 name:Uwuwit Si
 genotype:X
 info:
 num:1
-gnum:50
-popsiz:4
-lifespan:5000
-velocity:0
-distance:0
-vertvel:0
+gnum:0
+popsiz:6
+lifespan:5000.0
+velocity:0.0
+distance:0.0
+vertvel:0.0
 vertpos:-0.01
-user1:null
-user2:null
-user3:null
-uid:g6501
-
-org:
-name:Igoras Sy
-genotype:X[*]
-info:300.00% mutation of 'Uwuwit Si'
+user1:@Serialized:null
+user2:@Serialized:"2"
+user3:@Serialized:null
+uid:g1
+
+Genotype:
+name:Ezupan Si
+genotype:cX
+info:100.00% mutation of 'Uwuwit Si'
 num:2
-gnum:51
-popsiz:3
-lifespan:5000
-velocity:0
-distance:0
-vertvel:0
+gnum:1
+popsiz:2
+lifespan:5000.0
+velocity:0.0
+distance:0.0
+vertvel:0.0
 vertpos:-0.01
-user1:null
-user2:null
-user3:null
-uid:g6502
-
-org:
-name:Emofuf Sy
-genotype:wX[*]
-info:25.00% mutation of 'Igoras Sy'
+user1:@Serialized:null
+user2:@Serialized:null
+user3:@Serialized:null
+uid:g2
+
+Genotype:
+name:Omygut Sy
+genotype:cX[@]
+info:150.00% mutation of 'Ezupan Si'
 num:3
-gnum:52
-popsiz:3
-lifespan:5000
-velocity:0
-distance:0
-vertvel:0
+gnum:2
+popsiz:1
+lifespan:5000.0
+velocity:0.0
+distance:0.0
+vertvel:0.0
 vertpos:-0.01
-user1:null
-user2:null
-user3:null
-uid:g6503
+user1:@Serialized:null
+user2:@Serialized:null
+user3:@Serialized:null
+uid:g3
 
 Population:
@@ -304,7 +307,7 @@
 bodysim:1
 selfcol:0
-em_stat:0
-em_dyn:0
-en_assim:0
+em_stat:0.0
+em_dyn:0.0
+en_assim:0.0
 
 Population:
@@ -323,6 +326,6 @@
 bodysim:1
 selfcol:0
-em_stat:0
-em_dyn:0
-en_assim:0
-
+em_stat:0.0
+em_dyn:0.0
+en_assim:0.0
+
Index: java/main/src/test/resources/netfiles/standard_without_orgs.expt
===================================================================
--- java/main/src/test/resources/netfiles/standard_without_orgs.expt	(revision 107)
+++ java/main/src/test/resources/netfiles/standard_without_orgs.expt	(revision 107)
@@ -0,0 +1,280 @@
+sim_params:
+expdef:standard
+usercode:
+autosaveperiod:0
+overwrite:1
+filecomm:1
+lastCheckpoint:@Serialized:165
+createrr:1
+creatwarnfail:0
+importchk:0
+loadchk:0
+groupchk:0
+resetonexpdef:1
+user:@Serialized:null
+identity:-1
+initialgen:X
+capacity:200
+MaxCreated:1
+placement:0
+rotation:0
+creath:0.1
+p_nop:20.0
+evalcount:0
+p_mut:64.0
+p_xov:16.0
+xov_mins:0.0
+selrule:2
+delrule:0
+cr_c:0.0
+cr_life:0.0
+cr_v:1.0
+cr_gl:0.0
+cr_joints:0.0
+cr_nnsiz:0.0
+cr_nncon:0.0
+cr_di:0.0
+cr_vpos:0.0
+cr_vvel:0.0
+cr_norm:0
+cr_simi:0
+Energy0:5000.0
+e_meta:1.0
+feed:0
+feede0:200.0
+foodgen:
+feedtrans:1.0
+aging:0
+stagnation:0
+minfitness:0.0
+boostphase:1
+makesound:0
+savebest:0
+log:0
+notes:
+totaltestedcr:165
+totaltests:165
+wrldtyp:0
+wrldsiz:20.0
+wrldmap:
+wrldwat:-1.0
+wrldbnd:0
+wrldg:1.0
+simtype:0
+nnspeed:1.0
+odeshape:0
+odestep:0.05
+odemusclemin:0.0
+odemusclemax:10.0
+odemusclespeed:1.0
+odeairdrag:0.01
+odewaterdrag:0.5
+odewaterbuoy:1.0
+odeseed:0
+odesepsticks:0
+odeworlderp:0.2
+odeworldcfm:1e-05
+odecolmumin:0.1
+odecolmumax:5.0
+odecolbounce:0.1
+odecolbouncevel:0.01
+odecolsoftcfm:0.0
+odecolsofterp:0.0
+odecol2mumin:0.1
+odecol2mumax:1.0
+odecol2bounce:0.1
+odecol2bouncevel:0.01
+odecol2softcfm:0.0
+odecol2softerp:0.0
+gen_hilite:1
+gen_extmutinfo:0
+genoper_f0:0
+genoper_f1:0
+genoper_f2:0
+genoper_f3:0
+genoper_f4:0
+neuadd_N:1
+neuadd_Nu:0
+neuadd_G:1
+neuadd_T:1
+neuadd_S:1
+neuadd_Constant:1
+neuadd_Bend_muscle:1
+neuadd_Rotation_muscle:1
+neuadd_D:0
+neuadd_Fuzzy:0
+neuadd_VEye:0
+neuadd_VMotor:0
+neuadd_Sti:0
+neuadd_LMu:0
+neuadd_Water:0
+neuadd_Energy:0
+neuadd_Ch:0
+neuadd_ChMux:0
+neuadd_ChSel:0
+neuadd_Rnd:0
+neuadd_Sin:0
+neuadd_Delay:0
+neuadd_PIDV:0
+neuadd_Sf:0
+neuadd_Thr:0
+neuadd_Nn:0
+neuadd_SeeLight:0
+neuadd_PIDP:0
+neuadd_Light:0
+neuadd_SeeLight2:0
+f0_nodel_tag:1
+f0_nomod_tag:1
+f0_p_new:5.0
+f0_p_del:5.0
+f0_p_swp:10.0
+f0_p_pos:10.0
+f0_p_mas:10.0
+f0_p_frc:10.0
+f0_p_ing:10.0
+f0_p_asm:10.0
+f0_p_vsiz:0.0
+f0_j_new:5.0
+f0_j_del:5.0
+f0_j_stm:10.0
+f0_j_stf:10.0
+f0_j_rsf:10.0
+f0_j_vred:0.0
+f0_j_vgrn:0.0
+f0_j_vblu:0.0
+f0_n_new:5.0
+f0_n_del:5.0
+f0_n_prp:10.0
+f0_c_new:5.0
+f0_c_del:5.0
+f0_c_wei:10.0
+f1_xo_propor:0
+f1_smX:0.05
+f1_smJunct:0.02
+f1_smComma:0.02
+f1_smModif:0.1
+f1_mut_exmod:EeAaSsDdGgBbHh
+f1_nmNeu:0.05
+f1_nmConn:0.1
+f1_nmProp:0.1
+f1_nmWei:1.0
+f1_nmVal:0.05
+f2_mutAddOper:0.4
+f2_mutJointElem:0.33
+f2_mutNeuroElem:0.33
+f2_mutConnElem:0.33
+f2_mutDelOper:0.1
+f2_mutHandleOper:0.3
+f2_mutPropOper:0.2
+f3_mutSubstitution:0.6
+f3_mutSubstPerChar:0.1
+f3_mutDelIns:0.1
+f3_mutDelInsPerChar:0.05
+f3_mutDelInsLength:5
+f3_mutDuplication:0.05
+f3_mutTranslocation:0.15
+f3_xovGeneTransfer:0.8
+f3_xovCrossingOver:0.2
+f4_mut_add:50.0
+f4_mut_add_div:20.0
+f4_mut_add_conn:15.0
+f4_mut_add_neupar:5.0
+f4_mut_add_rep:10.0
+f4_mut_add_simp:50.0
+f4_mut_del:20.0
+f4_mut_mod:30.0
+genkonw0:1
+genkonw1:1
+genkonw2:1
+genkonw3:1
+genkonw4:1
+randinit:0.01
+nnoise:0.0
+touchrange:1.0
+bnoise_struct:0.0
+bnoise_vel:0.0
+ncl_N:1
+ncl_Nu:1
+ncl_G:1
+ncl_T:1
+ncl_S:1
+ncl_Constant:1
+ncl_Bend_muscle:1
+ncl_Rotation_muscle:1
+ncl_D:1
+ncl_Fuzzy:1
+ncl_VEye:1
+ncl_VMotor:1
+ncl_Sti:1
+ncl_LMu:1
+ncl_Water:1
+ncl_Energy:1
+ncl_Ch:1
+ncl_ChMux:1
+ncl_ChSel:1
+ncl_Rnd:1
+ncl_Sin:1
+ncl_Delay:1
+ncl_PIDV:1
+ncl_Sf:1
+ncl_Thr:1
+ncl_Nn:1
+ncl_SeeLight:1
+ncl_PIDP:1
+ncl_Light:1
+ncl_SeeLight2:1
+simil_method:0
+simil_parts:0.0
+simil_partdeg:1.0
+simil_neuro:0.5
+symPosSteps:10
+symAlphaSteps:20
+symBetaSteps:20
+minjoint:0.0
+maxjoint:2.0
+
+GenePool:
+name:Genotypes
+fitness:return 0.0+this.velocity*1.0;
+fitfun:0
+fitm:2.0
+fitma:2.0
+
+Population:
+name:Creatures
+energy:1
+death:1
+nnsim:2
+perfperiod:100
+stabilperiod:100
+killnostable:1000000
+stabledist:0.01
+enableperf:2
+colmask:13
+selfmask:65537
+othermask:131073
+bodysim:1
+selfcol:0
+em_stat:0.0
+em_dyn:0.0
+en_assim:0.0
+
+Population:
+name:Food
+energy:1
+death:1
+nnsim:0
+perfperiod:100
+stabilperiod:100
+killnostable:1000000
+stabledist:0.01
+enableperf:0
+colmask:148
+selfmask:131074
+othermask:65538
+bodysim:1
+selfcol:0
+em_stat:0.0
+em_dyn:0.0
+en_assim:0.0
+