Index: cpp/frams/neuro/impl/neuroimpl-body-gdk.h
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-body-gdk.h	(revision 112)
+++ cpp/frams/neuro/impl/neuroimpl-body-gdk.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/impl/neuroimpl-channels.cpp
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-channels.cpp	(revision 112)
+++ cpp/frams/neuro/impl/neuroimpl-channels.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/impl/neuroimpl-channels.h
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-channels.h	(revision 112)
+++ cpp/frams/neuro/impl/neuroimpl-channels.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/impl/neuroimpl-fuzzy-f0.cpp
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-fuzzy-f0.cpp	(revision 112)
+++ cpp/frams/neuro/impl/neuroimpl-fuzzy-f0.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/impl/neuroimpl-fuzzy-f0.h
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-fuzzy-f0.h	(revision 112)
+++ cpp/frams/neuro/impl/neuroimpl-fuzzy-f0.h	(revision 121)
@@ -1,7 +1,7 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
-/// this is a modul included into neuroimpl-fuzzy
+/// this is a module included into neuroimpl-fuzzy
 /// it converts string parameters - fuzzy sets and fuzzy rules - into appropriate variables
 
Index: cpp/frams/neuro/impl/neuroimpl-fuzzy.cpp
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-fuzzy.cpp	(revision 112)
+++ cpp/frams/neuro/impl/neuroimpl-fuzzy.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/impl/neuroimpl-fuzzy.h
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-fuzzy.h	(revision 112)
+++ cpp/frams/neuro/impl/neuroimpl-fuzzy.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/impl/neuroimpl-simple.cpp
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-simple.cpp	(revision 112)
+++ cpp/frams/neuro/impl/neuroimpl-simple.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/impl/neuroimpl-simple.h
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-simple.h	(revision 112)
+++ cpp/frams/neuro/impl/neuroimpl-simple.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/neurocls-f0-GDK-factory.h
===================================================================
--- cpp/frams/neuro/neurocls-f0-GDK-factory.h	(revision 112)
+++ cpp/frams/neuro/neurocls-f0-GDK-factory.h	(revision 121)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 
 // do not edit - generated automatically from "f0.def"
Index: cpp/frams/neuro/neurocls-f0-GDK-library.h
===================================================================
--- cpp/frams/neuro/neurocls-f0-GDK-library.h	(revision 112)
+++ cpp/frams/neuro/neurocls-f0-GDK-library.h	(revision 121)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 
 // do not edit - generated automatically from "f0.def"
Index: cpp/frams/neuro/neurofactory.cpp
===================================================================
--- cpp/frams/neuro/neurofactory.cpp	(revision 112)
+++ cpp/frams/neuro/neurofactory.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/neurofactory.h
===================================================================
--- cpp/frams/neuro/neurofactory.h	(revision 112)
+++ cpp/frams/neuro/neurofactory.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/neuroimpl.cpp
===================================================================
--- cpp/frams/neuro/neuroimpl.cpp	(revision 112)
+++ cpp/frams/neuro/neuroimpl.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/neuroimpl.h
===================================================================
--- cpp/frams/neuro/neuroimpl.h	(revision 112)
+++ cpp/frams/neuro/neuroimpl.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/neuroimplfiles-GDK.h
===================================================================
--- cpp/frams/neuro/neuroimplfiles-GDK.h	(revision 112)
+++ cpp/frams/neuro/neuroimplfiles-GDK.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/neurolibrary.cpp
===================================================================
--- cpp/frams/neuro/neurolibrary.cpp	(revision 112)
+++ cpp/frams/neuro/neurolibrary.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/neuro/neurolibrary.h
===================================================================
--- cpp/frams/neuro/neurolibrary.h	(revision 112)
+++ cpp/frams/neuro/neurolibrary.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 