Index: cpp/common/2d.h
===================================================================
--- cpp/common/2d.h	(revision 109)
+++ cpp/common/2d.h	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #ifndef _2D_H_
 #define _2D_H_
Index: cpp/common/Convert.cpp
===================================================================
--- cpp/common/Convert.cpp	(revision 109)
+++ cpp/common/Convert.cpp	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #include "Convert.h"
 
@@ -18,5 +22,5 @@
 int Convert::toInt(string s) {return atoi(s.c_str());}
 float Convert::toFloat(string s) {return (float)atof(s.c_str());}
-#ifndef __BORLANDC__ //szok: borland kompiluje ten plik w GUI i CLI ale nie w teatrze. Z jakichs powodow nie potrafi znalezc ::tolower i ::toupper, moze chodzi o pewne definy w <cctype> ale czemu tylko w teatrze?!
+#ifndef __BORLANDC__ //the borland compiler compiles this file in GUI and CLI, but not in the theater app. Somehow it cannot find ::tolower and ::toupper; maybe this is because of various #defines in <cctype>, but why only in the theater app??
 string Convert::toLowerCase(string s) {std::transform(s.begin(), s.end(), s.begin(), ::tolower);  return s;}
 string Convert::toUpperCase(string s) {std::transform(s.begin(), s.end(), s.begin(), ::toupper);  return s;}
@@ -118,2 +122,3 @@
 return string(ret,24); //24 znaki z pominieciem ostatniego \n
 }
+
Index: cpp/common/Convert.h
===================================================================
--- cpp/common/Convert.h	(revision 109)
+++ cpp/common/Convert.h	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #ifndef _CONVERT_H_
 #define _CONVERT_H_
Index: cpp/common/framsg.cpp
===================================================================
--- cpp/common/framsg.cpp	(revision 109)
+++ cpp/common/framsg.cpp	(revision 122)
@@ -1,7 +1,11 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #include "framsg.h"
 #include <common/nonstd_stdio.h>
 #include "Convert.h"
 
-char* MSG_LEVEL[]={"DEBUG","INFO","WARN","ERROR","CRITICAL"};
+const char* MSG_LEVEL[]={"DEBUG","INFO","WARN","ERROR","CRITICAL"};
 
 void FMprintf_va(const char *o,const char *m,int w,const char *bl,va_list va)
Index: cpp/common/framsg.h
===================================================================
--- cpp/common/framsg.h	(revision 109)
+++ cpp/common/framsg.h	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #ifndef _FRAMSG_H_
 #define _FRAMSG_H_
@@ -4,9 +8,9 @@
 #include <stdarg.h>
 
-extern char* MSG_LEVEL[];
+extern const char* MSG_LEVEL[];
 
 void FMprintf(const char *o,const char *m,int w,const char *bl, ...);
-void FMprintf_va(const char *o,const char *m,int w,const char *bl,va_list va);//inna nazwa bo bez tego nie odroznia parametru "string" od va_list i wywoluje zla wersje
-void printFM(const char *bl,...); //dla leniwych - zastepuje printf (zmieniona nazwa chociaz tutaj "prawdopodobienstwo" konfliktu jest niewielkie, musialoby byc wywolanie malego printa z kilkoma parametrami odpowiednich typow zeby niechcacy wywolal sie duzy print)
+void FMprintf_va(const char *o,const char *m,int w,const char *bl,va_list va); //a different name than FMprintf - otherwise the compiler could confuse the "string" parameter with va_list and could call the wrong function
+void printFM(const char *bl,...); //a shorthand for printf (a different name again to avoid the risk of confusion with the two functions above. This would be unlikely but possible when the argument types would match)
 void FramMessage(const char *o,const char *m,const char *bl,int w);
 
Index: cpp/common/nonstd_dir.h
===================================================================
--- cpp/common/nonstd_dir.h	(revision 109)
+++ cpp/common/nonstd_dir.h	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #ifndef _NONSTD_DIR_H_
 #define _NONSTD_DIR_H_
Index: cpp/common/nonstd_math.cpp
===================================================================
--- cpp/common/nonstd_math.cpp	(revision 109)
+++ cpp/common/nonstd_math.cpp	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #include "nonstd_math.h"
 
Index: cpp/common/nonstd_math.h
===================================================================
--- cpp/common/nonstd_math.h	(revision 109)
+++ cpp/common/nonstd_math.h	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #ifndef _NONSTD_MATH_H_
 #define _NONSTD_MATH_H_
@@ -28,4 +32,5 @@
 #define setRandomRandomSeed() rndGetInstance().randomize()
 
+
 //floating point specific numbers
 #include "stdlib.h"
@@ -37,10 +42,15 @@
 #endif
 
+#ifdef LINUX
+  #define _isnan(a) isnan(a)
+#endif
+
 #ifdef IPHONE
 	#define finite(x) (!isinf(x))
+  #define _isnan(a) isnan(a)
 #endif
 
 
-#if defined SHP && !defined TIZEN
+#if defined SHP
  //#define __assert_func(a,b,c,d) 0 //Currently, we are sorry to inform you that assert() is not yet supported. We have considered your request for internal discussion. Na szczêcie jest w³asna (byle by by³a, bo i tak zak³adamy ze assert ktore przeciez dziala tylko w trybie debug nie jest potrzebne na bada) implementacja w "bada-assert.cpp"
  #define isnan(x) false //isnan() sie nie linkuje
Index: cpp/common/nonstd_stdio.cpp
===================================================================
--- cpp/common/nonstd_stdio.cpp	(revision 109)
+++ cpp/common/nonstd_stdio.cpp	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #include "nonstd_stdio.h"
 #if defined _WIN32 && !defined SHP
Index: cpp/common/nonstd_stdio.h
===================================================================
--- cpp/common/nonstd_stdio.h	(revision 109)
+++ cpp/common/nonstd_stdio.h	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #ifndef _NONSTD_STDIO_H_
 #define _NONSTD_STDIO_H_
Index: cpp/common/nonstd_stl.h
===================================================================
--- cpp/common/nonstd_stl.h	(revision 109)
+++ cpp/common/nonstd_stl.h	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #ifndef _NONSTD_STL_H_
 #define _NONSTD_STL_H_
Index: cpp/common/random.h
===================================================================
--- cpp/common/random.h	(revision 109)
+++ cpp/common/random.h	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #include "nonstd.h" //LONGLONG
 #include <time.h> //time()
Index: cpp/common/threads.h
===================================================================
--- cpp/common/threads.h	(revision 109)
+++ cpp/common/threads.h	(revision 122)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #ifndef _THREADS_H_
 #define _THREADS_H_